package memory.vue;

import memory.controleur.Controleur;
import memory.controleur.ControleurFenetre;
import memory.controleur.ControleurNouvellePartie;
import memory.controleur.ControleurPartie;
import memory.modele.MemoryModele;
import memory.modele.PlateauModele;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDesktopPane;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JPanel;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;



/**
 * Classe qui va afficher la fenetre du jeu
 * @author Anthony Laplane
 */
public class FenetreJeu  {
	//private JDesktopPane JDesktopPane1;
	private FenetrePrincipale fenetre;
	private PlateauModele plateauModele;
	public JInternalFrame jifJeu;
	public JLabel jlabelTentatives = new JLabel();
	public JLabel jlabelScore = new JLabel();
	public JLabel jlabelScoreOrdinateur = new JLabel();
	public JPanel jpanGagne;
	public JPanel jpanPerdu;
	public JPanel jpanOrdi;
	public JPanel jpanCases;
	
	public FenetreJeu(FenetrePrincipale fenetre, PlateauModele plateauModele ){
		this.fenetre=fenetre;
		this.plateauModele = plateauModele;
		// On initialise notre fentre
		construire();
		
	}
	/**
	 * Mthode appeler par la mthode principale
	 * Cette mthode va ajouter les diffrents elements graphique  la fentre
	 */
	private void construire(){
		//this.fenetre = fenetre;
      	int nbLignes = plateauModele.retournerNbLignes();
      	int nbColonnes = plateauModele.retournerNbColonnes();
      	
		JInternalFrame jifJeu = new JInternalFrame("Jeu Memory Smiley", true, true, true, true);

		jifJeu.addInternalFrameListener(new InternalFrameAdapter(){
		public void internalFrameClosing(InternalFrameEvent ife){
			// on libre le thread
			ControleurFenetre.threadOrdinateur1 = null;
		}
		});
	  	jifJeu.setBounds(0, 0, 793, 545);
	  	jifJeu.setMaximizable(true);

	  	//jifJeu.setExtendedState(JInternalFrame.MAXIMIZED_BOTH);
      	fenetre.getContentPane().add(jifJeu, 2);
      	jifJeu.setVisible(true); // Needed since 1.3
      	JLayeredPane jpanPlateau = new JLayeredPane();
		//selection mode jeu
		jpanCases = new JPanel();
		jpanCases.setOpaque(false);
		// On centre le Jpan
		jpanCases.setBounds((500-(nbColonnes*100))/2,(500-(nbLignes*100))/2,793,600);
		
		// On cre un panel pour l'image de fond
		JPanel jpanFond = new JPanel();
		// On lui donne sa taille et position
		jpanFond.setBounds(0,0,800,600);
		// On appel la fonction qui charge l'image de fond
		chargerImageDeFond(jpanFond);

        // On cre le panel de la barre d'information
      	JPanel jpanBarre = new JPanel();
      	//jpanBarre.set
      	//jpanBarre.setPreferredSize(new Dimension(793,310));
      	jpanBarre.setBounds(0,0,793,30);
      	jpanBarre.setBackground(Color.black);
      	
      	JLabel jlabelNiveauDifficulte = new JLabel("Niveau de difficult : " + plateauModele.retournerDifficulteText());
      	jlabelNiveauDifficulte.setForeground(Color.white);
      	JLabel jlabelNiveau = new JLabel("Niveau : " + plateauModele.retournerNiveau());
      	jlabelNiveau.setForeground(Color.white);
      	jlabelTentatives.setText("Tentatives restantes : " + plateauModele.retournerTentatives());
      	jlabelTentatives.setForeground(Color.white);
      	
      	jpanBarre.add(jlabelNiveauDifficulte);      	
      	// Ajoute un espacement entre les composants
      	jpanBarre.add(Box.createRigidArea(new Dimension(50,0)));
      	jpanBarre.add(jlabelNiveau);
      	// Ajoute un espacement entre les composants
      	jpanBarre.add(Box.createRigidArea(new Dimension(50,0)));
      	jpanBarre.add(jlabelTentatives);
      	
      	// PANEL FIN PARTIE REUSSIE **************************************
        // On cre le panel de fin de partie gagne
      	this.jpanGagne = new JPanel();
      	jpanGagne.setBounds(120,100,500,320);
      	jpanGagne.setBackground(Color.black);
      	
		// On dfinit l'image
	    ImageIcon iconeGagne = new ImageIcon("media/gagne1.jpg");
	    // On insert cette image dans un Jlabel
	    JLabel labelImageGagne = new JLabel(iconeGagne);
	    // On insert le JLabel contenant l'image dans le JPanel
	    jpanGagne.add(labelImageGagne);
	    
      	jlabelScore.setText("Votre score : ");
      	jlabelScore.setForeground(Color.white);
      	jlabelScore.setFont(new Font("Dialog", 0, 18));
      	jpanGagne.add(jlabelScore);
      	
      	jlabelScoreOrdinateur.setText("Ordinateur : 30");
      	jlabelScoreOrdinateur.setForeground(Color.white);
      	jlabelScoreOrdinateur.setFont(new Font("Dialog", 0, 12));
      	jlabelScoreOrdinateur.setVisible(false);
      	jpanGagne.add(jlabelScoreOrdinateur);
      	
      	JButton btnRecommencer = new JButton(new RefaireNiveauAction(fenetre, "Refaire le niveau"));
      	// Ajoute un espacement entre les composants
      	jpanGagne.add(Box.createRigidArea(new Dimension(5,0)));
      	jpanGagne.add(btnRecommencer);
      	
      	JButton btnNiveauSuivant = new JButton(new NiveauSuivantAction(fenetre, "Niveau Suivant"));
      	// Ajoute un espacement entre les composants
      	jpanGagne.add(Box.createRigidArea(new Dimension(5,0)));
      	jpanGagne.add(btnNiveauSuivant);

      	jpanGagne.setVisible(false);
      	//***************************************************************
      	
      	// PANEL FIN PARTIE PERDUE **************************************
        // On cre le panel de fin de partie gagne
      	this.jpanPerdu = new JPanel();
      	jpanPerdu.setBounds(120,100,500,320);
      	jpanPerdu.setBackground(Color.black);
      	
		// On dfinit l'image
	    ImageIcon iconePerdu = new ImageIcon("media/perdu1.jpg");
	    // On insert cette image dans un Jlabel
	    JLabel labelImagePerdu = new JLabel(iconePerdu);
	    // On insert le JLabel contenant l'image dans le JPanel
	    jpanPerdu.add(labelImagePerdu);  	
	    JButton btnRejouer = new JButton(new RefaireNiveauAction(fenetre, "Rejouer le niveau"));
      	// Ajoute un espacement entre les composants
      	//jpanPerdu.add(Box.createRigidArea(new Dimension(50,0)));
     	
      	jpanPerdu.add(btnRejouer);
      	jpanPerdu.setVisible(false);

      	//***************************************************************
      	
      	// PANEL ORDI REFLECHIT **************************************
        // On cre le panel de fin de partie gagne
      	this.jpanOrdi= new JPanel();
      	jpanOrdi.setBounds(120,200,600,50);
      	jpanOrdi.setBackground(Color.black);
      	
		// On dfinit l'image
	   // ImageIcon iconePerdu = new ImageIcon("media/perdu1.jpg");
	    // On insert cette image dans un Jlabel
	   // JLabel labelImagePerdu = new JLabel(iconePerdu);
	    // On insert le JLabel contenant l'image dans le JPanel
	    //jpanOrdi.add(labelImagePerdu);  	
	    //JButton btnRejouer = new JButton(new RefaireNiveauAction(fenetre, "Rejouer le niveau"));
      	// Ajoute un espacement entre les composants
      	//jpanPerdu.add(Box.createRigidArea(new Dimension(50,0)));
	    JLabel jlabelReflechit = new JLabel();
      	jlabelReflechit.setText("L'ordinateur est en train de rflechir...");
      	jlabelReflechit.setForeground(Color.white);
      	jlabelReflechit.setFont(new Font("Dialog", 0, 16));
      	
      	jpanOrdi.add(jlabelReflechit);
      	jpanOrdi.setVisible(false);

      	//***************************************************************
      	

      	//nbLignes = 4;
      	//nbColonnes = 4;
      	Controleur.monControleurPartie =  new ControleurPartie(nbLignes*nbColonnes);
      	int i;
      	// On definit le compteur qui va nous permettre d'identifier une carte par sa position
      	int positionCarte = 0;
      	// On boucle sur le nombre de ligne
      	for (i=1;i<=nbLignes;i++){
      		System.out.println("lignes :"+nbLignes);
      		// On cre un Jpanel par ligne
      		JLayeredPane jpanLigne = new JLayeredPane();
      		//jpanLigne.setLayout(new FlowLayout());
          	jpanLigne.setOpaque(false);
          	jpanLigne.setPreferredSize(new Dimension(793,110));
          	// On boucle sur le nombre de colonnes
          	int j;
          	for (j=1;j<=nbColonnes;j++){
          		 
          		// On crer une case dans la colonne
          		new Case(jpanLigne, j);
          		//int numCartes = Controleur.monControleurPartie.retournerNumCarte(positionCarte);
          		//int numCartes = MemoryModele.monPlateauModele.retournerNumCarte(positionCarte);
          		int numCarte = plateauModele.retournerNumCarte(positionCarte);
          		//System.out.println("num cartes : " +numCartes);
          		// On crer une carte dans la colonne
          		new CarteVue(jpanLigne, jpanCases, i, j, positionCarte, numCarte);
          		// On crer la carte Modele
        	   
        	    
        	    Controleur.monControleurPartie.creerCarteModele(positionCarte, numCarte);
          		
          		// On incrmente le compteur de position
          		positionCarte = positionCarte+1;
          		
          	}
          	
          	
          	jpanCases.add(jpanLigne);
      	}
		
      	// On ajoute les diffrent JPanel  notre plateau
      	// avec en argument un entier diffrent pour superposer les elements
      	jpanPlateau.add(jpanOrdi,new Integer(3));
      	jpanPlateau.add(jpanPerdu,new Integer(3));
      	jpanPlateau.add(jpanGagne,new Integer(3));
      	jpanPlateau.add(jpanBarre,new Integer(2));
	    jpanPlateau.add(jpanCases,new Integer(1));
	    
	    jpanPlateau.add(jpanFond,new Integer(0));
	    jifJeu.add(jpanPlateau);
	    //jifJeu.validate();
	      
	}
	/**
	 * Mthode permettant d'affecter une image de fond
	 */
	private void chargerImageDeFond(JPanel jpanFond) {
			
			// On dfinit un objet de type ImageIcon contenant l'image de fond
		    ImageIcon iconeFond = new ImageIcon("media/plateau1.jpg");
		    // On insert cette image dans un Jlabel
		    JLabel labelImageFond = new JLabel(iconeFond);
		    // On position notre label et lui affecte une taille
		    // getIconWidth et getIconHeight rcupre la taille de notre ImageIcon
		    labelImageFond.setBounds(0, 0, iconeFond.getIconWidth(), iconeFond.getIconHeight());
		    
		    // On ajoute la labelImageFond au JDesktopPane1
		    // le deuxime argument new Integer(Integer.MIN_VALUE) affecte
		    // la valeur la plus petite possible pour un entier
		    // afin de garder notre image en fond
		    jpanFond.add(labelImageFond, new Integer(Integer.MIN_VALUE));
	}

	
}

