package memory.vue;
import memory.controleur.Controleur;
import memory.controleur.ControleurNouvellePartie;
import memory.controleur.ControleurPartie;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;


public class FenetreNouvellePartie extends JDialog implements ActionListener {
  private JLabel lblModeJeu, lblDifficulte;
  private JTextField nom, taille;
  private JComboBox jcmbModeJeu, cheveux;
  private JRadioButton radioDifficulte1,radioDifficulte2,radioDifficulte3,radioDifficulte4;
  private ButtonGroup bgDifficulte;
  private FenetrePrincipale parentPartie;
  
  public FenetreNouvellePartie(FenetrePrincipale parent) {
	 
    super(parent, true);
    parentPartie = parent;
    // Titre de la fenetre
    setTitle("Menu"); 
    
    this.getContentPane().setLayout(new FlowLayout());

    //selection mode jeu
    JPanel panModeJeu = new JPanel();
    panModeJeu.setBackground(Color.WHITE);
    panModeJeu.setPreferredSize(new Dimension(540,60));
    // On ajoute un cadre de titre
    panModeJeu.setBorder(BorderFactory.createTitledBorder("Mode de jeu"));
    // On cre le label
    lblModeJeu = new JLabel("Selectionnez le mode de jeu");
    // On crer la liste droulante des modes de jeu
    jcmbModeJeu = new JComboBox();
    // On ajoute les items  la liste
    jcmbModeJeu.addItem("Partie seul");
    jcmbModeJeu.addItem("Partie  deux joueurs");
    jcmbModeJeu.addItem("Partie contre l'ordinateur");
    // On ajoute les composant au panel
    panModeJeu.add(lblModeJeu);
    panModeJeu.add(jcmbModeJeu);        

    //selection difficult
    JPanel panDifficulte = new JPanel();
    panDifficulte.setBackground(Color.WHITE);
    panDifficulte.setPreferredSize(new Dimension(540,60));
    // On ajoute un cadre de titre
    panDifficulte.setBorder(BorderFactory.createTitledBorder("Niveau de difficult"));
//  On cre le label
    lblDifficulte = new JLabel("Selectionnez le niveau de difficult");
    // On cre les JRadioButton de difficul
    // Cration du JRadioButton
    radioDifficulte1 = new JRadioButton("Trs Facile");
    // On associe une valeur au JRadioButton
    radioDifficulte1.setMnemonic(1);
    // Cration du JRadioButton
    radioDifficulte2 = new JRadioButton("Facile");
    // On associe une valeur au JRadioButton
    radioDifficulte2.setMnemonic(2);
    // Cration du JRadioButton
    radioDifficulte3 = new JRadioButton("Normal");
    // On associe une valeur au JRadioButton
    radioDifficulte3.setMnemonic(3);
    // On definit ce JRadioButton comme selectionn par dfaut
    radioDifficulte3.setSelected(true);
    // Cration du JRadioButton
    radioDifficulte4 = new JRadioButton("Difficile");
    // On associe une valeur au JRadioButton
    radioDifficulte4.setMnemonic(4);
    // On definit la couleur de fond des JRadioButton  blanc
    radioDifficulte1.setBackground(Color.WHITE);
    radioDifficulte2.setBackground(Color.WHITE);
    radioDifficulte3.setBackground(Color.WHITE);
    radioDifficulte4.setBackground(Color.WHITE);
    // Le ButtonGroup va contenir tous les JRadioButton et va permettre de n'en
    // selectionner qu'un  la fois
    bgDifficulte = new ButtonGroup();
    // On ajout les JRadioButton au ButtonGroup
    bgDifficulte.add(radioDifficulte1);
    bgDifficulte.add(radioDifficulte2);
    bgDifficulte.add(radioDifficulte3);
    bgDifficulte.add(radioDifficulte4);
    // On ajoute les composant au panel
    panDifficulte.add(lblDifficulte);
    panDifficulte.add(lblDifficulte);    
    panDifficulte.add(radioDifficulte1);
    panDifficulte.add(radioDifficulte2);
    panDifficulte.add(radioDifficulte3);
    panDifficulte.add(radioDifficulte4);

    
    //JPanel contenuMenu= new JPanel();
    /*messagePane.add(new JLabel("Slectionnez un mode de jeu :"));
    JTextField cityField = new JTextField();
    messagePane.add(cityField);*/
    
    //contenuMenu.add(panModeJeu);

    
    getContentPane().add(panModeJeu);
    getContentPane().add(panDifficulte);
    getContentPane().setBackground(Color.WHITE);
    
    JPanel buttonPane = new JPanel();
    JButton button = new JButton("OK"); 
    buttonPane.add(button); 
    button.addActionListener(this);
    getContentPane().add(buttonPane, BorderLayout.SOUTH);
    setDefaultCloseOperation(DISPOSE_ON_CLOSE);
    pack(); 

    setSize(550,300);
    // On recupere la taille de la fenetre parente
    Dimension parentSize = parent.getSize(); 
    // On recupere les coordonnes de la fenetre parente
    Point p = parent.getLocation(); 
    // On recupere la taille de cette Jdialog
    Dimension tailleJdialog = getSize();
    // On place la Jdialog au centre de la fenetre parente
    setLocation(p.x + (parentSize.width / 2) - (tailleJdialog.width /2), p.y + parentSize.height / 2 - (tailleJdialog.height /2));
    setVisible(true);
  }
  public void actionPerformed(ActionEvent e) {
	  int difficulte = bgDifficulte.getSelection().getMnemonic();
	  System.out.println("difficulte :" + bgDifficulte.getSelection().getMnemonic());
	  int modeJeu = jcmbModeJeu.getSelectedIndex();
	  System.out.println("MODE DE JEU           : " + modeJeu);
	  if (modeJeu==1) {
		  JOptionPane.showMessageDialog(null, "Ce mode de jeu n'est pas encore disponible.", "Memory Smiley - 2008/2009", JOptionPane.INFORMATION_MESSAGE);
	  } else {
		  
		  //ControleurNouvellePartie nouvellePartie = new ControleurNouvellePartie(parentPartie, difficulte, 1);
		  Controleur.monControleurNouvellePartie =  new ControleurNouvellePartie(parentPartie, difficulte, 1, modeJeu);
		  
	      setVisible(false); 
	      dispose();
	  }
  }
 
}
