package memory.vue;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import memory.controleur.Controleur;
import memory.controleur.ControleurNouvellePartie;
import memory.modele.MemoryModele;

public class FenetreOptionsPartie extends JDialog implements ActionListener {
	  private FenetrePrincipale parentPartie;
	  private ButtonGroup bgTheme;
	  //private JRadioButton radioDifficulte1,radioDifficulte2,radioDifficulte3,radioDifficulte4;
	  
	  public FenetreOptionsPartie(FenetrePrincipale parent) {
		    super(parent, true);
		    parentPartie = parent;
		    // Titre de la fenetre
		    setTitle("Options"); 

		    
		    this.getContentPane().setLayout(new FlowLayout());
		    
		    // Le ButtonGroup va contenir tous les JRadioButton et va permettre de n'en
		    // selectionner qu'un  la fois
		    bgTheme = new ButtonGroup();
		    
		    // **** Theme1 *****************************************************
		    //Panel du theme1
		    JPanel panTheme1 = new JPanel();
		    panTheme1.setBackground(Color.WHITE);
		    panTheme1.setPreferredSize(new Dimension(540,180));
  
		    // On ajoute un cadre de titre
		    panTheme1.setBorder(BorderFactory.createTitledBorder("Thme 1"));
		    // On cre les JRadioButton de difficul
		    // Cration du JRadioButton
		    JRadioButton radioNiveauT1 = new JRadioButton("Choisir ce thme de carte : ");
		    // On associe une valeur au JRadioButton
		    radioNiveauT1.setMnemonic(1);
		    // On definit ce JRadioButton comme selectionn par dfaut
		    radioNiveauT1.setSelected(true);
		    // On definit la couleur de fond  blanc
		    radioNiveauT1.setBackground(Color.WHITE);
		    // On ajout le JRadioButton au ButtonGroup
		    bgTheme.add(radioNiveauT1);
		    // On ajout le JRadioButton au Panel
		    panTheme1.add(radioNiveauT1);
		    
			// On dfinit un objet de type ImageIcon contenant l'image du theme
		    ImageIcon iconeTheme1 = new ImageIcon("media/theme1.jpg");
		    // On insert cette image dans un Jlabel
		    JLabel labelTheme1 = new JLabel(iconeTheme1);
		    //labelImageFond2.setBounds(j*120, 0, iconeFond2.getIconWidth(), iconeFond2.getIconHeight());
		    panTheme1.add(labelTheme1);
		    
		    getContentPane().add(panTheme1);
		    // ***********************************************************
		    
		    // **** Theme2 *****************************************************
		    //Panel du theme2
		    JPanel panTheme2 = new JPanel();
		    panTheme2.setBackground(Color.WHITE);
		    panTheme2.setPreferredSize(new Dimension(540,180));
  
		    // On ajoute un cadre de titre
		    panTheme2.setBorder(BorderFactory.createTitledBorder("Thme 2"));
		    // On cre les JRadioButton de difficul
		    // Cration du JRadioButton
		    JRadioButton radioNiveauT2 = new JRadioButton("Choisir ce thme de carte : ");
		    // On associe une valeur au JRadioButton
		    radioNiveauT2.setMnemonic(2);
		    // On definit ce JRadioButton comme selectionn par dfaut
		    radioNiveauT2.setSelected(true);
		    // On definit la couleur de fond  blanc
		    radioNiveauT2.setBackground(Color.WHITE);
		    // On ajout le JRadioButton au ButtonGroup
		    bgTheme.add(radioNiveauT2);
		    // On ajout le JRadioButton au Panel
		    panTheme2.add(radioNiveauT2);
		    
			// On dfinit un objet de type ImageIcon contenant l'image du theme
		    ImageIcon iconeTheme2 = new ImageIcon("media/theme2.jpg");
		    // On insert cette image dans un Jlabel
		    JLabel labelTheme2 = new JLabel(iconeTheme2);
		    //labelImageFond2.setBounds(j*120, 0, iconeFond2.getIconWidth(), iconeFond2.getIconHeight());
		    panTheme2.add(labelTheme2);
		    
		    getContentPane().add(panTheme2);
		    // ***********************************************************
		    
		    
		    JPanel buttonPane = new JPanel();
		    JButton button = new JButton("OK"); 
		    buttonPane.add(button); 
		    button.addActionListener(this);
		    getContentPane().add(buttonPane, BorderLayout.SOUTH);
		    setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		    pack(); 
		    
		    setSize(550,450);
		    // On recupere la taille de la fenetre parente
		    Dimension parentSize = parent.getSize(); 
		    // On recupere les coordonnes de la fenetre parente
		    Point p = parent.getLocation(); 
		    // On recupere la taille de cette Jdialog
		    Dimension tailleJdialog = getSize();
		    // On place la Jdialog au centre de la fenetre parente
		    setLocation(p.x + (parentSize.width / 2) - (tailleJdialog.width /2), p.y + parentSize.height / 2 - (tailleJdialog.height /2));
		    setVisible(true);
	  }
	  public void actionPerformed(ActionEvent e) {
		  // On recupere la valeur du JRadio
		  int numTheme = bgTheme.getSelection().getMnemonic();
		  MemoryModele.theme = numTheme;

		    setVisible(false); 
		    dispose(); 
	  }

}