package memory.vue;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;

import javax.swing.DefaultDesktopManager;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDesktopPane;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JTextField;

import memory.controleur.Controleur;
import memory.controleur.ControleurFenetre;
import memory.controleur.ControleurXML;
import memory.modele.LectureXml;
import memory.modele.PlateauModele;
import memory.modele.MemoryModele;

public class FenetrePrincipale extends JFrame{
	// On dclare le JdesktopPane pour comme priv pour qu'il puisse tre utilis
	// par l'ensemble des mthodes de la classe et par les classes filles
	public JDesktopPane JDesktopPane1;
	private Integer layer;
	public FenetrePrincipale(){
		super();
		construire();//On initialise notre fentre
		
	}
	private void construire(){
		
		// On instancie le controleur de fenetre
		Controleur.monControleurFenetre = new ControleurFenetre(this);
		// On initialise le theme a 1
		MemoryModele.theme = 1;

		construireMenu();
		// on appel la mthode qui constuit le JDesktopPane
		construireJDesktopPane();
		// on appel la mthode charge l'image de fond
		chargerImageDeFond();
		// On instancie le controleur grant les donnes
		Controleur.monControleurXML = new ControleurXML();

		//	On donne un titre  l'application
	    setTitle("Memory Smiley"); 
	    // On donne une taille  notre fentre si l'utilisateur quitte l'tat maximis
	    setSize(800,600); 
	    setResizable(false); //On interdit la redimensionnement de la fentre
	    // On prcise  l'application de quitter lors de la fermeture de la fenetre
	    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	    
	}
	 protected void construireMenu() {
			// Construction du menu
			JMenuBar menuBar = new JMenuBar();
			JMenu menu1 = new JMenu("Fichier");
			JMenuItem nouvelPartie = new JMenuItem(new NouvellePartieAction(this, "Nouvelle partie"));
			menu1.add(nouvelPartie);
			JMenuItem chargerPartie = new JMenuItem(new ChargerNiveauAction(this, "Reprendre une partie"));
			menu1.add(chargerPartie);
			JMenuItem optionPartie = new JMenuItem(new OptionsPartieAction(this, "Options"));
			menu1.add(optionPartie);
			JMenuItem quitter = new JMenuItem(new QuitterAction(this, "Quitter"));
			menu1.add(quitter);
			menuBar.add(menu1);
			JMenu menu2 = new JMenu("?");
			JMenuItem aPropos = new JMenuItem(new AboutBoxAction(this, "A propos de"));
			menu2.add(aPropos);
			menuBar.add(menu2);
			setJMenuBar(menuBar);
	 }
	// Mthode permettant d'affecter une image de fond
	private void chargerImageDeFond() {
			
			// On dfinit un objet de type ImageIcon contenant l'image de fond
		    ImageIcon iconeFond = new ImageIcon("media/couv1.jpg");
		    // On insert cette image dans un Jlabel
		    JLabel labelImageFond = new JLabel(iconeFond);
		    // On position notre label et lui affecte une taille
		    // getIconWidth et getIconHeight rcupre la taille de notre ImageIcon
		    labelImageFond.setBounds(0, 0, iconeFond.getIconWidth(), iconeFond.getIconHeight());
		    
		    // On ajoute la labelImageFond au JDesktopPane1
		    // le deuxime argument new Integer(Integer.MIN_VALUE) affecte
		    // la valeur la plus petite possible pour un entier
		    // afin de garder notre image en fond
		    JDesktopPane1.add(labelImageFond, new Integer(Integer.MIN_VALUE));
		  }
	
	// Mthode de cration du JDesktopPane
	private JDesktopPane construireJDesktopPane(){
		
		// On instancie un JDesktopPane
		JDesktopPane1 = new JDesktopPane();
		// On affecte ce JDesktopPane comme notre Panel
	    setContentPane(JDesktopPane1);
		
		return JDesktopPane1;
	}


}
